Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::OnePole Class Reference

STK one-pole filter class. More...

`#include <OnePole.h>`

Inheritance diagram for stk::OnePole:

List of all members.

## Public Member Functions
| OnePole (StkFloat thePole=0.9)
| The default constructor creates a low-pass filter (pole at z = 0.9).
| ~OnePole ()
| Class destructor.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat a1, bool clearState=false)
| Set all filter coefficients.
void | setPole (StkFloat thePole)
| Set the pole position in the z-plane.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK one-pole filter class.

This class implements a one-pole digital filter. A method is provided for setting the pole position along the real axis of the z-plane while maintaining a constant peak filter gain.

by Perry R. Cook and Gary P. Scavone, 1995 - 2010.

## Member Function Documentation

void stk::OnePole::setPole | ( | StkFloat | thePole | ) |

Set the pole position in the z-plane.

This method sets the pole position along the real-axis of the z-plane and normalizes the coefficients for a maximum gain of one. A positive pole value produces a low-pass filter, while a negative pole value produces a high-pass filter. This method does not affect the filter gain value.

StkFrames & stk::OnePole::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

StkFrames & stk::OnePole::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

The documentation for this class was generated from the following file:

- OnePole.h

The Synthesis ToolKit in C++ (STK)
©1995-2010 Perry R. Cook and Gary P. Scavone. All Rights Reserved.